import java.awt.Color;
import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.util.ArrayList;



public class koza {

	private double x;
	private double y;
	private double dlzka;
	private double uhol;
	private boolean skryta;
	public ArrayList<double_string> najblizsie;
	
	koza dalsia;
	
	public koza(){
		dalsia = null;
		x = 0;
		y = 0;
		dlzka = 0;
		uhol = 0;
		skryta = false;
		najblizsie = new ArrayList<double_string>();
		
	}
	public koza(double xx, double yy, double dlzkaa, double uholl){
		x = xx;
		y = yy;;
		dlzka = dlzkaa;
		uhol = uholl;
		dalsia = null;
		skryta = false;
		najblizsie = new ArrayList<double_string>();
		
	}
	public koza(double xx, double yy, double dlzkaa, double uholl, boolean skrytaa){
		x = xx;
		y = yy;;
		dlzka = dlzkaa;
		uhol = uholl;
		dalsia = null;
		skryta = skrytaa;
		najblizsie = new ArrayList<double_string>();
		
	}
	
	public koza oznacena(double ox, double oy){
		
		double xn = x + dlzka * Math.cos(Math.toRadians(uhol));
        double yn = y + dlzka * Math.sin(Math.toRadians(uhol));
		
		if ((ox > xn-2) && (oy > yn-2) && (ox < xn+2) && (oy < yn+2) ){
			System.out.print("Oznacena cast koze \n");
			return this;
		}else{
			if (dalsia != null){
				return dalsia.oznacena(ox, oy);
			}
			
		}
		return null;
		
	}
	public void kresli(Graphics2D g2,koza oznacena_koza, int mod,boolean prva, double prva_x, double prva_y){
		
		if (prva){
			
		}
	
		if (!skryta){
			double xk = x + dlzka * Math.cos(Math.toRadians(uhol));
			double yk = y + dlzka * Math.sin(Math.toRadians(uhol));
			
			g2.setStroke(new BasicStroke(2, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
			g2.setPaint (Color.gray);
			if (oznacena_koza == this){
				g2.setPaint (Color.cyan);
			}
			g2.drawLine((int)x,(int)y,(int)xk,(int)yk);
			g2.drawOval((int)x-2, (int)y-2, 4, 4);
			g2.drawOval((int)xk-2, (int)yk-2, 4, 4);
			
			if (prva){
				prva = false;
				prva_x = x;
				prva_y = y;
			}
			
		}
		if (dalsia != null){
			dalsia.kresli(g2,oznacena_koza, mod,prva,prva_x,prva_y);
		}else{
			if (mod == 3){
				g2.setStroke(new BasicStroke(2, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
				g2.setPaint (Color.gray);
				if (oznacena_koza == this){
					g2.setPaint (Color.cyan);
				}
				double xk = x + dlzka * Math.cos(Math.toRadians(uhol));
				double yk = y + dlzka * Math.sin(Math.toRadians(uhol));
				
				g2.drawLine((int)xk,(int)yk,(int)prva_x,(int)prva_y);
				g2.drawOval((int)xk-2, (int)yk-2, 4, 4);
				g2.drawOval((int)prva_x-2, (int)prva_y-2, 4, 4);
			}
		}
	
	}

	public void pridaj_dalsiu(double xx, double yy, double dlzkaa, double uholl){
		dalsia = new koza(xx,yy,dlzkaa,uholl);
		
	}
	public void pridaj_dalsiu(double dlzkaa, double uholl){
		
		double xn = x + dlzka * Math.cos(Math.toRadians(uhol));
        double yn = y + dlzka * Math.sin(Math.toRadians(uhol));
        
		dalsia = new koza(xn,yn,dlzkaa,uholl);
		
	}

	
	public double getx(){
		return x;	
	}
	public double gety(){
		return y;	
	}
	public double getdlzka(){
		return dlzka;	
	}
	public double getuhol(){
		return uhol;	
	}
	public koza getdalsia(){
		return dalsia;	
	}
	
	public void setx(double xx){
		x = xx;
	}
	public void sety(double yy){
		y = yy;	
	}
	public void setdlzka(double dlzkaa){
		dlzka = dlzkaa;	
	}
	public void setuhol(double uholl){
		uhol = uholl;	
	}
	
	public void odstan(koza kozaa){
		
		if (dalsia!= null){
			if (dalsia.equals(kozaa)){
				dalsia = null;
			}else{
				dalsia.odstan(kozaa);
			}
			
		}
	}
	public String DoStringu(){
		String ret = "";
		ret += "s;" + x + ";" + y  + ";" + dlzka + ";" +  uhol  + ";" + skryta  + "\n";
		
		if (dalsia != null){
			ret += dalsia.DoStringu();	
		}
		
		return ret;
		
	}
	
	public void posun(double dlzkaa, double uholl){
		dlzka = dlzkaa;
		uhol = uholl;
		posun_dalsiu_kozu();
	}
	public void posun_dalsiu_kozu(){
		
		if (dalsia != null){
			double xn = x + dlzka * Math.cos(Math.toRadians(uhol));
	        double yn = y + dlzka * Math.sin(Math.toRadians(uhol));
	        dalsia.setx(xn);
	        dalsia.sety(yn);
	        dalsia.posun_dalsiu_kozu();
		}
	}
	
	public boolean obsahuje_najblizsie(String meno){
		
		for (int i = 0; i < najblizsie.size(); i++){
			if (najblizsie.get(i).getDruha().equals(meno)){
				return true;
			}
		}
		return false;
	}



	
}
