import java.applet.Applet;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class skeleton extends Applet implements ActionListener{
	private static final long serialVersionUID = 1L;
	
	//nastavenia
    private int sirka = 800; //sirka
    private int vyska = 600; //vyska bez menu
    private int hrubka = 6; //velkost pixela
    public kost root_kost;
    public koza koza;
    
    public int pocet_kosti = 0;
    public int mod = 0; //0-> editovanie kosti, 1-> koza pre oznacenu kost
    
    public kost oznacena; //aktualne oznacena kost
    public koza oznacena_koza;
    public kost animacia_oznacena;
    
    
    
    //vzhlad
    JPanel nPanel = new JPanel();
    
	MyCanvas plocha = new MyCanvas(sirka,vyska,hrubka,this);
	JButton button_nacitaj = new JButton("Nataj");
	JButton button_uloz = new JButton("Ulo");
	JButton button_nova = new JButton("Nov");
	JRadioButton  uprava_kosti = new JRadioButton("prava kost");
	JRadioButton  uprava_koze = new JRadioButton("prava koe");
	JRadioButton  animacia = new JRadioButton("Animcia");
	JButton button_zmaz_kost = new JButton("Zma kos");
	JButton button_zmaz_kozu = new JButton("Zma kou");
	
	JLabel label_uhol =  new JLabel("uhol: 0000");
	
	JSlider sliderR = getSlider(0, 255, 0, 50, 5);
	JSlider sliderG = getSlider(0, 255, 0, 50, 5);
	JSlider sliderB = getSlider(0, 255, 0, 50, 5);
	FarbaCanvas farba_nahlad = new FarbaCanvas();
	
	JButton button_uloz_vlastnosti = new JButton("Ulo vlastnosti");
	
	JTextField text_min_uhol = new JTextField();
	JTextField text_max_uhol = new JTextField();
	
	public void init(){
		System.out.print("init" + "\n");
		
		button_nacitaj.setActionCommand("nacitaj");
		button_nacitaj.addActionListener(this);
		
		button_uloz.setActionCommand("uloz");
		button_uloz.addActionListener(this);
		
		button_nova.setActionCommand("nova");
		button_nova.addActionListener(this);
		
		uprava_kosti.setActionCommand("uprava_kosti");
		uprava_kosti.addActionListener(this);
		uprava_kosti.setSelected(true);
		
		uprava_koze.setActionCommand("uprava_koze");
		uprava_koze.addActionListener(this);
		
		animacia.setActionCommand("animacia");
		animacia.addActionListener(this);
		
		button_zmaz_kost.setActionCommand("zmaz_kost");
		button_zmaz_kost.addActionListener(this);
		
		button_zmaz_kozu.setActionCommand("zmaz_kozu");
		button_zmaz_kozu.addActionListener(this);
		button_zmaz_kozu.setEnabled(false);
		
		button_zmaz_kozu.setActionCommand("zmaz_kozu");
		button_zmaz_kozu.addActionListener(this);
		button_zmaz_kozu.setEnabled(false);
		
		button_uloz_vlastnosti.setActionCommand("uloz_vlastnosti");
		button_uloz_vlastnosti.addActionListener(this);
		button_uloz_vlastnosti.setEnabled(false);
		
		text_min_uhol.setColumns(10);
		text_min_uhol.setMaximumSize(text_min_uhol.getPreferredSize());
		text_max_uhol.setColumns(10);
		text_max_uhol.setMaximumSize(text_min_uhol.getPreferredSize());
		
		setLayout(new BorderLayout());
		nPanel.setLayout(new BoxLayout(nPanel, BoxLayout.Y_AXIS));
		nPanel.add(button_nacitaj);
		nPanel.add(button_uloz);
		nPanel.add(button_nova);
		
		nPanel.add(Box.createVerticalStrut(30));
		nPanel.add(uprava_kosti);
		nPanel.add(uprava_koze);
		nPanel.add(animacia);
		
		nPanel.add(Box.createVerticalStrut(30));
		nPanel.add(button_zmaz_kost);
		nPanel.add(button_zmaz_kozu);
		
		nPanel.add(Box.createVerticalStrut(30));
		nPanel.add(new JLabel("Vlastnosti kosti:"));
		nPanel.add(label_uhol);
		nPanel.add(new JLabel("min uhol:"));
		nPanel.add(text_min_uhol);
		nPanel.add(new JLabel("max uhol:"));
		nPanel.add(text_max_uhol);
		nPanel.add(new JLabel("farba:"));
		nPanel.add(sliderR);
		nPanel.add(sliderG);
		nPanel.add(sliderB);
		nPanel.add(farba_nahlad);

		nPanel.add(button_uloz_vlastnosti);
		nPanel.add(Box.createVerticalStrut(50));
		
		add(nPanel, BorderLayout.EAST);
		add(plocha, BorderLayout.CENTER);
	}
	
	//spustenie
	public void start(){
		System.out.print("start" + "\n");
		setSize(sirka, vyska+30);
		//co sa ma stat pri spusteni
		odznac_kost();
		
	}
	public void stop(){
	   
	}
	public void destroy(){
	    
	}
	
	//odchytavanie akcii v applete
	public boolean action(Event e, Object o){ 
	    return false;
	}

	//odchytavanie akcii tlacidiel
	@Override
	public void actionPerformed(ActionEvent e) {
        if ("uloz".equals(e.getActionCommand())) {
        	System.out.print("uloz \n");
        	export_import export = new export_import("kostra.txt");
        	String s = root_kost.DoStringu("");
        	if (koza != null){
        		s += koza.DoStringu();
        	}
        	
            export.uloz(s);
        }else if ("nacitaj".equals(e.getActionCommand())) {
        	System.out.print("nacitaj \n");
        	export_import imp = new export_import("kostra.txt");
        	nacitaj(imp.nacitaj());
        	plocha.repaint();
        }else if ("nova".equals(e.getActionCommand())) {
        	System.out.print("nova \n");
        	root_kost = null;
        	koza = null;
        	odznac_kost();
        	odznac_kozu();
			mod = 0;
			root_kost = new kost(200,200,"root",1,hrubka,0,0,0,true,Color.black);
			root_kost.pridaj("kost_1", 100, hrubka, 90,45+180,135+180, Color.black);
			pocet_kosti = 1;
        	plocha.repaint();
        }else if ("uprava_kosti".equals(e.getActionCommand())) {
        	System.out.print("uprava kosti \n");
        	uprava_kosti.setSelected(true);
        	uprava_koze.setSelected(false);
        	odznac_kozu();
        	odznac_anim();
        	button_zmaz_kost.setEnabled(true);
        	button_zmaz_kozu.setEnabled(false);
        	animacia.setSelected(false);
        	mod = 0;
        	plocha.repaint();
        	
        }else if ("uprava_koze".equals(e.getActionCommand())) {
        	System.out.print("uprava koze \n");
        	uprava_kosti.setSelected(false);
        	uprava_koze.setSelected(true);
        	button_zmaz_kost.setEnabled(false);
        	button_zmaz_kozu.setEnabled(true);
        	animacia.setSelected(false);
        	odznac_kost();
        	odznac_anim();
        	mod = 1;
        	plocha.repaint();
        	
        }else if ("zmaz_kost".equals(e.getActionCommand())) {
        	System.out.print("zmaz kost \n");
        	if (oznacena != null){
        		root_kost.odstran_dieta(oznacena);
        		odznac_kost();
        		plocha.repaint();
        	}
        }else if ("zmaz_kozu".equals(e.getActionCommand())) {
        	System.out.print("zmaz kozu \n");
        	if (oznacena_koza != null){
        		odstran_kozu(oznacena_koza);
        		odznac_kozu();
        		plocha.repaint();
        	}
        }else if ("uloz_vlastnosti".equals(e.getActionCommand())) {
        	System.out.print("uloz vlastnosti \n");
        	if (oznacena != null){
        		Color c = new Color(sliderR.getValue(), sliderG.getValue(), sliderB.getValue());
        		oznacena.setFarba(c);
        		
        		double max_uhol = Double.parseDouble(text_max_uhol.getText());
        		double min_uhol = Double.parseDouble(text_min_uhol.getText());
        		
        		oznacena.setuhol_max(max_uhol);
        		oznacena.setuhol_min(min_uhol);
        		text_max_uhol.setText("" + (int)max_uhol);
        		text_min_uhol.setText("" + (int)min_uhol);
        	}
        }else if ("animacia".equals(e.getActionCommand())) {
        	System.out.print("animacia \n");
        	uprava_kosti.setSelected(false);
        	uprava_koze.setSelected(false);
        	button_zmaz_kost.setEnabled(false);
        	button_zmaz_kozu.setEnabled(false);
        	animacia.setSelected(true);
        	odznac_kost();
        	odznac_kozu();
        	mod = 3;
        	plocha.repaint();
        	koza_najblizsie();
        }
        	
    }
	
	private void nacitaj(ArrayList<String> pole){
		
		String[] tmp = pole.get(0).split(";");
		
		if (tmp[0].equals("k")){
		
			if (tmp[1].equals("")){
				root_kost = null;
				koza = null;
				odznac_kost();
				odznac_kozu();
				pocet_kosti = 0;
				mod = 0;
				uprava_kosti.setSelected(true);
	        	uprava_koze.setSelected(false);
	        	button_zmaz_kost.setEnabled(true);
	        	button_zmaz_kozu.setEnabled(false);
	        	animacia.setSelected(false);
				
				String meno_otca = tmp[1];
				String skryta_s = tmp[2];
				Double x = Double.parseDouble(tmp[3]);
				Double y = Double.parseDouble(tmp[4]);
				Double dlzka = Double.parseDouble(tmp[5]);
				int hrubka = Integer.parseInt(tmp[6]);
				double uhol = Double.parseDouble(tmp[7]);
				double uhol_min = Double.parseDouble(tmp[8]);
				double uhol_max = Double.parseDouble(tmp[9]);
				String meno = tmp[10];
				
				Color farba = new Color(Integer.parseInt(tmp[11]),Integer.parseInt(tmp[12]),Integer.parseInt(tmp[13]));
				
				
				boolean skryta = false;
				if (skryta_s.equals("true")){
					skryta = true;
				}
				
				root_kost = new kost(x,y,meno,dlzka,hrubka,uhol,uhol_min,uhol_max,skryta,farba);
				
				for (Iterator<String> iter = pole.iterator(); iter.hasNext();  ) {
					tmp = iter.next().split(";");
					if (tmp.length > 2){
						if (!tmp[1].equals("") && tmp[0].equals("k")){
							meno_otca = tmp[1];
							skryta_s = tmp[2];
							x = Double.parseDouble(tmp[3]);
							y = Double.parseDouble(tmp[4]);
							dlzka = Double.parseDouble(tmp[5]);
							hrubka = Integer.parseInt(tmp[6]);
							uhol = Double.parseDouble(tmp[7]);
							uhol_min = Double.parseDouble(tmp[8]);
							uhol_max = Double.parseDouble(tmp[9]);
							meno = tmp[10];
							
							
							farba = new Color(Integer.parseInt(tmp[11]),Integer.parseInt(tmp[12]),Integer.parseInt(tmp[13]));
							
							skryta = false;
							if (skryta_s.equals("true")){
								skryta = true;
							}
							//System.out.print(root_kost.DoStringu("") + "\n");
							kost najdena = root_kost.getdieta(meno_otca);
							//System.out.print("hladam:" + meno_otca + " nasiel som: " +najdena + "\n");
							if (najdena != null){
								najdena.pridaj(meno, dlzka, hrubka, uhol, uhol_min, uhol_max,farba);
								pocet_kosti++;
							}
						}else if (tmp[0].equals("s")){
							x = Double.parseDouble(tmp[1]);
							y = Double.parseDouble(tmp[2]);
							dlzka = Double.parseDouble(tmp[3]);
							uhol = Double.parseDouble(tmp[4]);
							skryta_s = tmp[5];
							
							skryta = false;
							if (skryta_s.equals("true")){
								skryta = true;
							}
							
							if (koza == null){
								koza =  new koza(x, y, dlzka, uhol,skryta);
							}else{
								koza koza_tmp = koza;
								while (koza_tmp.getdalsia() != null){
									koza_tmp = koza_tmp.getdalsia();
								}
								koza_tmp.pridaj_dalsiu(x, y, dlzka, uhol);
								
							}
	
							
						}
					}
				}
			}
			
		}
		
		
	}
	
	public void odznac_kost(){
		oznacena = null;
		button_uloz_vlastnosti.setEnabled(false);
	}
	
	public void odznac_kozu(){
		oznacena_koza = null;
	}
	
	public void odznac_anim(){
		animacia_oznacena = null;
	}
	
	public void oznacila_sa_kost(){
		button_uloz_vlastnosti.setEnabled(true);
		text_min_uhol.setText("" + (int)oznacena.getuhol_min());
		text_max_uhol.setText("" + (int)oznacena.getuhol_max());
		Color c = oznacena.getFarba();
		sliderR.setValue(c.getRed());
		sliderG.setValue(c.getGreen());
		sliderB.setValue(c.getBlue());
		farba_nahlad.zmen_farbu(c.getRed(), c.getGreen(), c.getBlue());
		
	}
	
	public void posunula_sa_kost(){
		if (oznacena != null){
			label_uhol.setText("uhol: " + ((int)oznacena.getuhol()+180));
		}else if (animacia_oznacena != null){
			label_uhol.setText("uhol: " + ((int)animacia_oznacena.getuhol()+180));
		}
	}
	
	
	public JSlider getSlider(int min, int max, int init, int mjrTkSp, int mnrTkSp) {
	    JSlider slider = new JSlider(JSlider.HORIZONTAL, min, max, init);
	    slider.setPaintTicks(true);
	    slider.setMajorTickSpacing(mjrTkSp);
	    slider.setMinorTickSpacing(mnrTkSp);
	    slider.setPaintLabels(true);
	    slider.addChangeListener(new SliderListener());
	    return slider;
	  }
	
	class SliderListener implements ChangeListener {

		public void stateChanged(ChangeEvent e) {
			farba_nahlad.zmen_farbu(sliderR.getValue(), sliderG.getValue(), sliderB.getValue());
			
		}
	    
		
	}

	public void odstran_kozu(koza kozaa){
		
		if (koza != null){
			if (koza.equals(kozaa)){
				koza = null;
			}else{
				koza.odstan(kozaa);	
			}		
			
		}
	}
	public int getmod(){
		return mod;
	}
	
	private void koza_najblizsie(){
		
		koza tmp_koza = koza;
		while (tmp_koza != null){
			 pocitaj_najblizsie(tmp_koza);
			 pocitaj_w(tmp_koza);
			 tmp_koza = tmp_koza.dalsia;
		}
	}
	
	
	//vypocitanie najblizsich kosti pre body koze
	private void pocitaj_najblizsie(koza tmp_koza){
		
		ArrayList<double_string> vzdialenosti = new ArrayList<double_string>();

		root_kost.vzdialenosti(tmp_koza.getx(), tmp_koza.gety(), vzdialenosti);
		
		Collections.sort(vzdialenosti, new Comparator<Object>(){
			 
	        public int compare(Object o1, Object o2) {
	        	double_string p1 = (double_string) o1;
	        	double_string p2 = (double_string) o2;
	        	if (p1.getPrva() > p2.getPrva()){
	        		return -1;
	        	}
	           return 1;
	        }

	    });
		
		
		tmp_koza.najblizsie.clear();
		
		System.out.print("------------------\n");
		for (int i = 0; (i < 3) && (vzdialenosti.size()-i > 0) ; i++){
			tmp_koza.najblizsie.add(vzdialenosti.get(vzdialenosti.size()-i-1));
			System.out.print(vzdialenosti.get(vzdialenosti.size()-i-1).getPrva() + " " + vzdialenosti.get(vzdialenosti.size()-i-1).getDruha() + "\n");			
		}
		
	}
	
	private void pocitaj_w(koza tmp_koza){
		double sucet = 0;
		double tmp_w;
		//vypocet w
		for (int i = 0; i < tmp_koza.najblizsie.size(); i++){
			tmp_w = 1/tmp_koza.najblizsie.get(i).getPrva();
			tmp_koza.najblizsie.get(i).setW(tmp_w);
			sucet += tmp_w;
		}
		//normalizacia w
		for (int i = 0; i < tmp_koza.najblizsie.size(); i++){
			tmp_w = (1/sucet)* tmp_koza.najblizsie.get(i).getW();
			tmp_koza.najblizsie.get(i).setW(tmp_w);
		}
	}
	
	public void prepocitaj_kozu(String meno_kosti){
		koza tmp_koza = koza;
		while (tmp_koza != null){
			prepocitaj_jednu_kozu(tmp_koza);
			tmp_koza = tmp_koza.dalsia;
		}
		prepocitaj_uhly();
	}
	
	private void prepocitaj_jednu_kozu(koza tmp_koza){

		kost tmp_kost;
		double_string tmp_najblizsie;
		double startX = 0;
		double startY = 0;
		double x_old;
		double y_old;
		matica_pohybu maticaPohybu;
		
		for (int i = 0; i < tmp_koza.najblizsie.size(); i++){
			tmp_najblizsie = tmp_koza.najblizsie.get(i);
			tmp_kost = root_kost.getdieta(tmp_najblizsie.getDruha());
			maticaPohybu = tmp_kost.getMaticuPohybu();

				
				x_old = tmp_koza.getx();
				y_old = tmp_koza.gety();
			
				startX += tmp_najblizsie.getW()* (maticaPohybu.getA()*x_old+maticaPohybu.getC()*y_old+maticaPohybu.getTx());
				startY += tmp_najblizsie.getW()* (maticaPohybu.getB()*x_old+maticaPohybu.getD()*y_old+maticaPohybu.getTy());

			
		}
		tmp_koza.setx(startX);
		tmp_koza.sety(startY);
		
		
		
	}
	private void prepocitaj_uhly(){
		
		koza tmp_koza = koza;
		if (tmp_koza != null){
			
			while (tmp_koza.getdalsia() != null){
				
				double uholl = Math.atan2( tmp_koza.getdalsia().gety() - tmp_koza.gety() , tmp_koza.getdalsia().getx() - tmp_koza.getx() )* 180 / Math.PI;
				tmp_koza.setuhol(uholl);
				
				/*double xn = tmp_koza.getx() + tmp_koza.getdlzka() * Math.cos(Math.toRadians(tmp_koza.getuhol()));
		        double yn = tmp_koza.gety() + tmp_koza.getdlzka() * Math.sin(Math.toRadians(tmp_koza.getuhol()));
		        
		        
		        tmp_koza.getdalsia().setx(xn);
		        tmp_koza.getdalsia().sety(yn);*/
				
				double ax = (tmp_koza.getx() - tmp_koza.getdalsia().getx()) * (tmp_koza.getx() - tmp_koza.getdalsia().getx());
				double ay = (tmp_koza.gety() - tmp_koza.getdalsia().gety()) * (tmp_koza.gety() - tmp_koza.getdalsia().gety());
				
				double dlzkaa =  Math.sqrt(ax + ay);
				tmp_koza.setdlzka(dlzkaa);
		        
				tmp_koza = tmp_koza.getdalsia();
			}
			
			
		}
		
		
	}
	
	
}
	
